#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icon.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#comments-start
MadMACs from Irongeek and Glj12
For more information on this code read the readme file or visit http://irongeek.com 
Consider this code GPLed
#comments-end
#include <File.au3>
Global $mainkey="HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002bE10318}\"
;Begin Core Logic
;Yes, the below code is redundant, but I decided to err on the side of clarity over brevity. 
Dim $option= StringLower($CmdLineRaw)
Select 
	Case $option= "remove"
		RemoveSettings()
	Case $option= "config" or (Not FileExists(@ScriptDir & "\mac-config.txt")) 
		ListNICSAndSetupConfigFile()
		SetMACUsingConfigFile(@ScriptDir & "\mac-config.txt")
		SetHostnameFromFileIfThere(@ScriptDir & "\dic.txt")	
	Case $option= "doittoit"
		SetMACUsingConfigFile(@ScriptDir & "\mac-config.txt")
		SetHostnameFromFileIfThere(@ScriptDir & "\dic.txt")	
	Case Else
		$tmp = MsgBox(259, "Remove Settings?", "Do you wish to remove MadMACs from startup and clear the registry? Click No to configure MadMACs instead or Cancel to forget the whole matter." & @CRLF & "Version 1.2") 
			select 
				case $tmp=6 
					RemoveSettings()
				case $tmp=7
					ListNICSAndSetupConfigFile()
					SetMACUsingConfigFile(@ScriptDir & "\mac-config.txt")
					SetHostnameFromFileIfThere(@ScriptDir & "\dic.txt")
				case Else
					;do nothing
			EndSelect
EndSelect	
;End Core Logic

Func ListNICSAndSetupConfigFile()
	Dim $exit=0, $i=1, $tmp=0
	MsgBox(0, "Welcome to MadMACs","Welcome to MadMACs, the MAC address randomizer from Irongeek and Glj12." & @CRLF & _
                        	"To find the latest version of this application and its documentation visit http://irongeek.com and look in the apps section. " & _ 
							"If you want MadMACs to randomly set your hostname make a text file called dic.txt in the same directory as the binary. MadMACs will randomly select a word from it and make that your hostname." & @CRLF & _
							"Version 1.2")
	$tmp = MsgBox(4, "Clear Settings", "Clear the current mac-config.txt config file and registry entries if it's present?")
	If $tmp=6 then 
		FileDelete (@ScriptDir & "\mac-config.txt") 
		RemoveSettings()
	endif
	while not $exit
		$nicnum = RegEnumKey($mainkey, $i)
		If @error = -1 then $exit=1 
		$bustype=RegRead ( $mainkey & $nicnum, "BusType" )
		$driverdesc=RegRead ( $mainkey & $nicnum, "DriverDesc" )
		If $bustype<>"" then 
			$tmp = MsgBox(260, "NIC Settings", "Set a custom/random MAC for " & @CRLF & $driverdesc & " (NIC ID " &  $nicnum & ")?") 
			If $tmp=6 then 
				$tmp = InputBox ( "Prefix", "Type in the Prefix or the full MAC you want for " & $driverdesc & @CRLF & "(I would recommend leaving the default 00 prefix to make sure you set a valid MAC)", "00")
				if @Error=0 then 
					FileWriteLine (@ScriptDir & "\mac-config.txt", $driverdesc & "|||" & $nicnum  & "|||" & $tmp)
				EndIf
			Endif
		EndIf
		$i=$i+1
	wend
	$tmp = MsgBox(4, "Start Up", "Set MadMACs to run from its current location at start up?")
	If $tmp=6 then RegWrite("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Run", "RandMAC", "REG_SZ", @AutoItExe & " doittoit")
	return 0
EndFunc

Func SetMAC($nicid, $newmac)
		RegWrite($mainkey & $nicid, "NetworkAddress", "REG_SZ", $newmac)
EndFunc

Func MakeRandomMAC($MACPrefix="")
	$rmac=""
	for $i = 1 to (12-StringLen($MACPrefix))
		$rmac=$rmac & Hex(random(0,15,1),1)
	Next
	if $rmac <> "FFFFFFFFFFFF" or "000000000000" Then
		Return $MACPrefix & $rmac
	Else
		Return MakeRandomMAC()
	endif
EndFunc

Func SetMACUsingConfigFile($filename)	
	if FileExists($filename) then
		;MsgBox(0,"","t")
		$file=FileOpen($filename,0)
		$line=FileReadLine($file)
		Do
			;MsgBox(0,"",$line)
			$configarray=StringSplit($line,"|||",1)
			SetMAC($configarray[2],MakeRandomMAC($configarray[3]))
			$line=FileReadLine ($file)
		until $line=""
	EndIf
EndFunc

Func SetHostnameFromFileIfThere($filename)
	if FileExists($filename) then
		$maxlinecount=_FileCountLines( $filename )
		$tmp=Random(0,$maxlinecount,1)
		$hostname = FileReadLine($filename,$tmp)
		$hostname = StringLeft(StringRegExpReplace($hostname, "[^/a-zA-Z0-9_-]", ""),15) ; Filter bad characters, and truncate to 15 characters
		RegWrite("HKEY_LOCAL_MACHINE\SYSTEM\ControlSet001\Control\ComputerName\ComputerName\", "ComputerName", "REG_SZ",  $hostname)
		RegWrite("HKEY_LOCAL_MACHINE\SYSTEM\ControlSet001\Services\Tcpip\Parameters\", "NV Hostname", "REG_SZ",  $hostname)
		RegWrite("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\ComputerName\ComputerName\", "ComputerName", "REG_SZ",  $hostname)
		RegWrite("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters\", "NV Hostname", "REG_SZ",  $hostname)
	EndIf
EndFunc

Func RemoveSettings()
	RegDelete("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Run", "RandMAC") 
	MsgBox(0, "","Deleted from startup and registry cleared.")
	Dim $exit=0, $i=1, $ai=0
	while not $exit
		$nicnum = RegEnumKey($mainkey, $i)
		If @error = -1 then $exit=1
		$bustype=RegRead ( $mainkey & $nicnum, "BusType" )
		$driverdesc=RegRead ( $mainkey & $nicnum, "DriverDesc" )
		If $bustype<>"" then 
			RegDelete($mainkey & $nicnum, "NetworkAddress")
		EndIf
		$i=$i+1
	wend
EndFunc
